/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2018/12/15
 * Description 		 : USB豸ö
 *                     ʵֻbulkдͶ, ep:0x02 ep:0x82
 *******************************************************************************/

#include "CH57x_common.h"

__attribute__((aligned(4)))  UINT8 RxBuffer[MAX_PACKET_SIZE];      // IN, must even address
__attribute__((aligned(4)))  UINT8 TxBuffer[MAX_PACKET_SIZE];      // OUT, must even address




volatile uint8_t ENDP_TOG = 0;

void logs_hex_dump(uint8_t *data,uint32_t length) {
    uint32_t i;
    for(i=0;i<length;i++) {
        PRINT("%02X ",data[i]);
    }
    PRINT("\r\n");
}


UINT8 *write_and_read( UINT8 *pBuf, UINT16 pLen ) {

    volatile uint8_t s;
    memcpy( TxBuffer,pBuf,pLen );
    R8_UH_TX_LEN = pLen;
    s = USBHostTransact( USB_PID_OUT<< 4 | 0x02,(ENDP_TOG&0x80)?( 0xC0 ):0,2000 );
#if 1
    if( s == ERR_SUCCESS ) {
        ENDP_TOG^=0X80;
        while(1) {
            s = USBHostTransact( USB_PID_IN<< 4 | 0x02,(ENDP_TOG&0x40)?( 0xC0 ):0,2000 );
            if(s == ERR_SUCCESS ) {
                pLen = R8_USB_RX_LEN;
                ENDP_TOG^=0x40;
                break;
            } else if (s == (USB_PID_NAK | ERR_USB_TRANSFER)) {
                DelayUs(20);
                PRINT("nak\r\n");
            } else {
                PRINT("unexpect error in usb in\r\n");
                break;
            }
        }
    } else {
        PRINT("usb error \r\n");
    }
#endif

    return RxBuffer;;
}




void bulk_test(void) {
    uint8_t tx_buf[64];

    uint8_t *rx_p;

    for(uint8_t i=0;i<=64;i++) {
        memset(tx_buf,i,64);
        PRINT("tx buf len=%d \r\n",i);
        logs_hex_dump(tx_buf,i);
        rx_p = write_and_read(tx_buf,i);
        PRINT("rx buf \r\n");
        logs_hex_dump(rx_p,64);
    }
}

int main()
{
  UINT8 s;

  SetSysClock( CLK_SOURCE_PLL_60MHz );
  DelayMs( 5 );
  /* ѹ */
  PowerMonitor( ENABLE, HALevel_2V1 );

  GPIOA_SetBits( GPIO_Pin_9 );
  GPIOA_ModeCfg( GPIO_Pin_8, GPIO_ModeIN_PU );
  GPIOA_ModeCfg( GPIO_Pin_9, GPIO_ModeOut_PP_5mA );
  UART1_DefInit();
  PRINT( "Start @ChipID=%02X\n", R8_CHIP_ID );

  pHOST_RX_RAM_Addr = RxBuffer;
  pHOST_TX_RAM_Addr = TxBuffer;
  USB_HostInit();
  PRINT( "Wait Device In\n" );


  while( 1 )
  {
    s = ERR_SUCCESS;
    if ( R8_USB_INT_FG & RB_UIF_DETECT )
    {    // USBж
      R8_USB_INT_FG = RB_UIF_DETECT;
      s = AnalyzeRootHub();
      if ( s == ERR_USB_CONNECT )
        FoundNewDev = 1;
    }
    
    if ( FoundNewDev || s == ERR_USB_CONNECT )
    {    // µUSB豸
          FoundNewDev = 0;
          mDelaymS( 200 );    // USB豸ղδȶ,ʵȴUSB豸ٺ,ζ
          s = InitRootDevice();    // ʼUSB豸
          if ( s == ERR_SUCCESS ) {
              PRINT("InitRootDevice done\r\n");
              ENDP_TOG = 0;

              bulk_test();
          }

    }
  }
}

